/*
  GameEngine4.h - Arduino Game Engine for a ST7565 based 12864 LCD.
  Created by Thomas Baum, th.baum@online.de, 27.10.2015
*/

#ifndef _GameEngine1_H_
#define _GameEngine1_H_

#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif

#include "Display.h"
#include "Joypad.h"

class GameEngine1 {
	public:
          
		GameEngine1();
                void init(byte contrast);
                void clearVideoBuffer(void);
		void drawPixel(byte x, byte y);
                void drawLine(byte x1, byte y1, byte x2, byte y2);
                void drawBitmap(byte x, byte y, byte width, byte height, const byte bitmap[]);
                void drawValue(byte x, byte y, byte value);
                boolean update();
                boolean isFrameCount(byte frame);
                boolean isButtonPressed(int button);
                void beep();
                
                uint32_t frameCount;
                uint16_t frameDurationMicros;
                uint32_t frameStartMicros, frameEndMicros;
                uint8_t timePerFrame;
                uint32_t nextFrameMillis;
                Joypad joypad;
                
        private:
                boolean isCurserPaneActive;
                boolean isNavigationPaneActive;
                boolean isItemPaneActive;
                byte curserPaneX;
                byte curserPaneY;
                byte curserPaneWidth;
                byte curserPaneHeight;
                byte curserX;
                byte curserY;
                
                byte itemX;
                byte itemY;
                byte itemWidth;
                byte itemHeight;
                const byte* itemIMG;
                byte item;
                
                byte navigationPaneX;
                byte navigationPaneY;
                byte navigationPaneWidth;
                byte navigationPaneHeight;
                byte navigationEntries;
                
                byte location;
                byte action;
                const byte* navigationBackground;
                const byte* background;
                const byte* curser;
                const byte* scene;
                
                int frames;
                byte time;
                int score;
                int lives;
};

#endif
