#include "GameEngine1.h"
#include "SPI.h"

byte ballX, ballY;
byte collisionX = 1;
byte collisionY = 1;
byte player1X = 10;
byte player1Y = 10;
byte player2X = 118;
byte player2Y = 10;
byte level;
GameEngine1 engine = GameEngine1();

void setup(){
  engine.init(20);
  ballX = 64;
  ballY = 32;
  level = 0;
}

void loop(){
  if(engine.update()){
    controlBall(); 
    if(engine.isFrameCount(10 - (level/10))) {
      moveBall();         
    }
    if(engine.isFrameCount(25 - (level/4))) {
      movePlayer();   
    }
    drawPlayer();
    drawBall();
    drawField();
  } 
}

void drawBall() {
  engine.drawLine(ballX, ballY - 1, ballX, ballY + 1);
  engine.drawLine(ballX - 1, ballY, ballX + 1, ballY);
}

void drawPlayer() {
  engine.drawLine(player1X, player1Y - 5, player1X, player1Y + 5);
  engine.drawLine(player1X - 1, player1Y - 5, player1X -1, player1Y + 5);
  engine.drawLine(player2X, player2Y - 5, player2X, player2Y + 5);
  engine.drawLine(player2X + 1, player2Y - 5, player2X + 1, player2Y + 5);
}

void drawField() {
  engine.drawValue(62, 0, level);
  engine.drawLine(64, 9, 64, 64);
}

void movePlayer() {
  if (player1Y < 7) {
    player1Y++;
  }
  if (player1Y > 55) {
    player1Y--;
  }
  player1Y = (player1Y -1 + random(3));
  if (player2Y < 7) {
    player2Y++;
  }
  if (player2Y > 55) {
    player2Y--;
  }
  player2Y = (player2Y -1 + random(3));
}

void moveBall() {
  if (ballX == 1 || ballX == 127) {
    setup();  
  }
  if (ballY == 1 || ballY == 63) {
    collisionY = collisionY * -1;  
  }
  if (abs(ballX - player1X) <=2 && abs(ballY - player1Y) < 9) {
    collisionX = collisionX * -1;
    level++; 
  }
  if (abs(ballX - player2X) <=2 && abs(ballY - player2Y) < 9) {
    collisionX = collisionX * -1;
    level++; 
  }
  ballX = ballX + collisionX;
  ballY = ballY + collisionY;
}

void controlBall() {
  if(engine.isButtonPressed(UP) && ballY > 2){
    ballY = ballY - 1;
  }
  if(engine.isButtonPressed(DOWN) && ballY < 61){
    ballY = ballY + 1;
  }
  if(engine.isButtonPressed(LEFT) && ballX > 13){
    ballX = ballX - 1;
  }
  if(engine.isButtonPressed(RIGHT) && ballX < 115){
    ballX = ballX + 1;
  }
}

