#include "GameEngine1.h"
#include "SPI.h"

GameEngine1 engine = GameEngine1();

byte snailX = 64;
byte snailY = 32;

const PROGMEM byte snail [] = {
  0x78, 0x8D, 0x36, 0x84, 0xB7, 0x0C, 0xF8, 0x40, 0x20, 0xA0, 0xA0, 0xA0, 0xA0, 0x40, 0x80, 0x00,
  0x60, 0xB9, 0x8F, 0x80, 0x80, 0x87, 0x9D, 0xB0, 0xA7, 0xAD, 0xAA, 0xA6, 0xA0, 0xB1, 0xDB, 0x46
};

void setup(){
  engine.init(20);
}

void loop(){
  if(engine.update()){
    controlSnail();
    drawSnail(); 
  } 
}

void controlSnail() {
  if(engine.isButtonPressed(UP)){
    snailY = snailY - 1;
  }
  if(engine.isButtonPressed(DOWN)){
    snailY = snailY + 1;
  }
  if(engine.isButtonPressed(LEFT)){
    snailX = snailX - 1;
  }
  if(engine.isButtonPressed(RIGHT)){
    snailX = snailX + 1;
  }
}

void drawSnail() {
  engine.drawBitmap(snailX, snailY, 16, 16, snail);
}

