#include "GameEngine2.h"
#include "SPI.h"

GameEngine2 engine = GameEngine2();
extern const byte PROGMEM background[];
int snakeMoveX = +1;
int snakeMoveY = 0;
byte itemX = 15;
byte itemY = 8;
word level;

void setup() {
  engine.init(25);
  engine.setTileArea(2, 2, 22, 15);
  engine.setBackground(background);
  engine.setScorePane(96, 56);
  //engine.test();
  level = 1;
  engine.updateScore(level);
  engine.layer1.push({6, 8, 0});
  engine.layer2.push({itemX, itemY, 1});
}

void loop() {
  if (engine.update()) {
    if (isAlive()) {
      controlSnake();
      if (engine.isFrameCount(18 - (level / 2))) {
        moveSnake();
      }
    } else {
      engine.beep(150, 1000);
      engine.layer1.clear();
      engine.layer2.clear();
      delay(3000);
      setup();
    }
  }
}

void moveSnake() {
  Tile head = engine.layer1.getLast();
  engine.layer1.push({head.x + snakeMoveX, head.y + snakeMoveY, head.bitmap});
  if (head.x == itemX && head.y == itemY) {
    engine.beep();
    level++;
    engine.updateScore(level);  
    itemX = random(16);
    itemY = random(16);
    engine.layer2.pop();
    engine.layer2.push({itemX, itemY, 1});
  } else {
    engine.layer1.pop();
  }
}

boolean isAlive() {
  Tile head = engine.layer1.getLast();
  if (head.x < 0 || head.y < 0 || head.x >= 22 || head.y >= 15) {
    return false;
  }
  for (int i = 0; i < engine.layer1.count() -1; i++) {
    if (engine.layer1.getItem(i).x == head.x && engine.layer1.getItem(i).y == head.y) {
      return false;
    }
  }
  return true;
}

void controlSnake() {
  if (engine.isButtonPressed(UP)) {
    snakeMoveY = - 1;
    snakeMoveX = 0;
  }
  if (engine.isButtonPressed(DOWN)) {
    snakeMoveY = + 1;
    snakeMoveX = 0;
  }
  if (engine.isButtonPressed(LEFT)) {
    snakeMoveX = - 1;
    snakeMoveY = 0;
  }
  if (engine.isButtonPressed(RIGHT)) {
    snakeMoveX = + 1;
    snakeMoveY = 0;
  }
}

