#include "GameEngine3.h"
#include "SPI.h"

extern const byte PROGMEM tileSet[];
extern const byte PROGMEM startSplash[];
extern const byte PROGMEM scoreSplash[];
GameEngine3 engine = GameEngine3();
word level, score;
byte newPosition = 2;
byte oldPosition = 2;
boolean isRainGap = false;
boolean isAlive;

void setup() {
  engine.init(25);
  engine.setTileSet(tileSet);
  isAlive = true;
  level = 1;
  engine.showStartSplash(startSplash);
}

void loop() {
  if (engine.update()) {
    if (isAlive) {
      controlRudi();
      moveRudi();
      if (engine.isFrameCount(50 - (level / 6))) {
        moveDrops();
      }
    } else {
      engine.beep(150, 1000);
      delay(2000);
      score = level * 10;
      engine.showScoreSplash(65, 30, score, scoreSplash);
      setup();
    }
  }
}

void moveRudi() {
  if (engine.getTile(newPosition, 3) != 0) {
    engine.setTile(oldPosition, 3, 255);
    oldPosition = newPosition;
    engine.setTile(newPosition, 3, 1);
  } else {
    engine.setTile(oldPosition, 3, 255);
    oldPosition = newPosition;  
    engine.setTile(newPosition, 3, 2);
    isAlive = false;
  }
}

void moveDrops() {
  level++;
  engine.scrollDown();
  if (isRainGap) {
    isRainGap = false;
    for (int b = 0; b < 8; b++) {
      if (random(2)) {
        engine.setTile(b, 0, 0);
      }
    }
  } else {
    isRainGap = true;
  }
}

void controlRudi() {
  if (engine.isButtonPressed(LEFT) && newPosition > 0) {
    oldPosition = newPosition;
    newPosition --;
  }
  if (engine.isButtonPressed(RIGHT) && newPosition < 7) {
    oldPosition = newPosition;
    newPosition ++;
  }
}

