#include "GameEngine5.h"
#include "SPI.h"
GameEngine5 engine = GameEngine5();

extern const char level1[] PROGMEM;
extern const byte player[] PROGMEM;
extern const byte structures[] PROGMEM;
extern const byte decoration[] PROGMEM;
extern const byte objects[] PROGMEM;
extern const byte statusBitmap[] PROGMEM;

int coins;
int lives;
int time;

void setup() {
  engine.init(25);
  engine.setStructureTileSet(structures);
  engine.setDecorationTileSet(decoration);
  engine.setObjectTileSet(objects);
  engine.setPlayerTile(player);
  engine.setStatusPane(statusBitmap);

  //engine.addObjectPattern(vx, vy, jx, jy, gravity, deadly, objectID);
  engine.addObjectPattern(0, 0, 0, 0, false, false,  0); //Coin
  engine.addObjectPattern(-0.3, 0.4, -1, 0, true, true,  1); //Turtle
  engine.addObjectPattern(0, -0.3, 0, -1, false, true, 2); //Rock
  engine.addObjectPattern(-0.4, 0.15, -1, -1.01, true, true,  3); //Jumper
  engine.addObjectPattern(0, 0.15, 0, -1.01, true, false,  4); //TimeBooster

  engine.loadLevel(level1);

  engine.registerCollideAction(playerCollide);

  coins = 0;
  lives = 2;
  time = 40;
  engine.updateStatus(lives, coins, time);
}

void loop() {
  if (engine.update()) {
    engine.updatePlayer();
    engine.drawPlayer();
    engine.drawLevel();
    engine.updateObjects();
    if (engine.isFrameCount(50)) {
      time--;
      engine.updateStatus(lives, coins, time);
    }
    engine.drawStatus();
    checkVitality();
  }
}

void playerCollide(byte objectID, boolean isDeadly) {
  if(isDeadly) {
    tone(3, 200, 200);
    lives--;
  }
  switch (objectID) {
    case 0:
      coins++;
      tone(3, 800, 20);
      //engine.updateStatus(lives, coins, 0);
      break;
    case 4:
      time = time + 50;
      tone(3, 800, 20);
      break;
    default:
    break;
  }
  engine.updateStatus(lives, coins, time);
}

void checkVitality() {
  if (time == 0 && lives >= 0) {
    time = 40;
    tone(3, 200, 200);
    lives--;
  } else if (lives < 0) {
    engine.loadLevel(level1);
    lives = 2;
    time = 40;
  }
}

