/*
 *  pbm2hex.c
 */
#include <stdio.h>
#include <string.h> 
   
int main(int argc, const char **argv) {   
    FILE *fp,*fout;   
    unsigned short t,widthbmp,heightbmp;      //bmp store width and height   
    unsigned int width,height;   
    unsigned char bmp,ch1,ch2,heightlcd;   
    unsigned char image[1024];   
    unsigned char temp[64][128];   
    unsigned char lcd[1024];   
	const char *name="screen";
	if(argc>1) name=argv[1];
	char pbm[80],header[80],line[80];
	pbm[0]=0;
	header[0]=0;
	strcat(pbm,name);
	strcat(pbm,".pbm");
	strcat(header,name);
	strcat(header,".h");
    int i,j,k,b;   
    if((fp=fopen(pbm,"rb"))==NULL) {   
        printf("Can't open %s\n",pbm);   
        return 0;   
    }   
    if((fout=fopen(header,"wt"))==NULL) {   
        printf("Can't open %s\n",header);   
        return 0;   
    }   
    ch1=fgetc(fp);   
    ch2=fgetc(fp);   
    if((ch1!='P')||(ch2!='1')) {   
        printf("Not PBM file\n");   
        return 0;   
    }
    while(ch2<255 && ch2!='\n') ch2=fgetc(fp);
    ch2=fgetc(fp);
	if(ch2=='#')
	    while(ch2<255 && ch2!='\n') ch2=fgetc(fp);
	fgets(line,80,fp);
	sscanf(line,"%i %i",&width,&height);
	for(i=0;i<height;i++) {
		for(j=0;j<width;j++) {
			ch2=fgetc(fp);
			while(ch2<255 && ch2!='0' && ch2!='1') ch2=fgetc(fp);
			temp[i][j]=ch2-'0';
		}
	}
    fclose(fp);
    if(height%8==0) {   
        heightbmp=height;   
        heightlcd=height/8;   
    }   
    else {   
        heightbmp=(height/8+1)*8;   
        heightlcd=height/8+1;   
    }   
    for(i=0;i<heightlcd;i++) {
	b=i*8;
	for(j=0;j<width;j++) {
	    ch2=0;
	    for(k=0;k<8;k++) {
		if(temp[b+k][j]==1)
		    ch2 |= 1<<k;
	    }				
	    lcd[i*width+j]=ch2;
	}
    }
    fprintf(fout,"//width=%i heightlcd=%i\n",width,heightlcd);   
   
    fprintf(fout,"const unsigned char %s[%d]={%d,%d,\n ",name,width*heightlcd+2,width,heightlcd);   
    k = 0;
    for(i=0;i<heightlcd;i++) {
        for(j=0;j<width;j++) {  
            fprintf(fout," 0x%02x,",lcd[j+i*width]);
            k++;
            if(k==16) {
                fprintf(fout,"\n ");
                k=0;
            }
        }
    }   
    fprintf(fout,"};\n");   
   
    printf("ok\n");   
	fflush(fout);
	fclose(fout);
    return 1;   
}