#include "GameEngine6.h"
#include "SPI.h"

typedef enum location {
  cellFront, cellBack, guardRoom};
typedef enum action {
  look, speak, go, pick, put, use};
typedef enum item {
  empty, stone, slat, key};

extern const byte PROGMEM curserIMG[];
extern const byte PROGMEM actionIMG[];

extern const byte PROGMEM emptyItemIMG[];
extern const byte PROGMEM stoneItemIMG[];
extern const byte PROGMEM slatItemIMG[];
extern const byte PROGMEM keyItemIMG[];

extern const byte PROGMEM cellFrontIMG[];
extern const byte PROGMEM cellBackIMG[];
extern const byte PROGMEM guardRoomIMG[];

extern const byte PROGMEM startSplash[];

GameEngine6 engine = GameEngine6();

void setup() {
  engine.init(20);
  engine.clearVideoBuffer();
  engine.setCurserPane(40, 0, 88, 64, curserIMG);
  engine.setActionPane(0, 0, 40, 48, actionIMG, 6);
  engine.setItemPane(0, 48, 16, 16);
  engine.setItem(stone, stoneItemIMG);
  engine.setLocation(cellBack, cellBackIMG);
  engine.start();
  engine.showStartSplash(startSplash);
  engine.drawInfo("In de kasteelkerker");
  engine.drawInfo("Dag 472");
}

void loop() {
  if (engine.update()) {   
    if (engine.isButtonPressed(B)) {
      engine.nextAction();
      engine.drawScene();
    }
    if (engine.isButtonPressed(A)) {
      switch(engine.getLocation()) {
      case cellFront: 
        checkCellFront(); 
        break;
      case cellBack: 
        checkCellBack(); 
        break;
      case guardRoom: 
        checkGuardRoom(); 
        break;
      default: 
        break;
      }
    }
  }
}

