/*
  Joypad.h - Arduino Game Engine for a ST7565 based 12864 LCD.
  Created by Thomas Baum, th.baum@online.de, 27.10.2015
*/

#include "Joypad.h"

void Joypad::init() {
    pinMode(A0, INPUT_PULLUP);
    pinMode(7, OUTPUT);
    digitalWrite(7, LOW);
    pinMode(2, OUTPUT);
    digitalWrite(2, LOW);
    buttons[0] = JOYPAD_BUTTON_RIGHT_PIN;
    buttons[1] = JOYPAD_BUTTON_LEFT_PIN;
    buttons[2] = JOYPAD_BUTTON_DOWN_PIN;
    buttons[3] = JOYPAD_BUTTON_UP_PIN;
    buttons[4] = JOYPAD_BUTTON_A_PIN;
    buttons[5] = JOYPAD_BUTTON_B_PIN;
}

boolean Joypad::isPressed(byte button) {
    byte time = 15;
    if (time <= 1) {
        if ((buttonStates[button] != 255) && (buttonStates[button]))
            return true;
    } else {
        if ((buttonStates[button] != 255) && ((buttonStates[button] % time) == 1))
            return true;
    }
    return false;
}

boolean Joypad::isReleased(byte button) {
    if (buttonStates[button] == 255)
        return true;
    else
        return false;
}

boolean Joypad::repeat(byte button, byte time) {
    if (time <= 1) {
        if ((buttonStates[button] != 255) && (buttonStates[button]))
            return true;
    } else {
        if ((buttonStates[button] != 255) && ((buttonStates[button] % time) == 1))
            return true;
    }
    return false;
}

uint8_t Joypad::isLongPressed(byte button){
    if(buttonStates[button] != 255)
        return buttonStates[button];
    else
        return 0;
    
}

void Joypad::update() { 
    for (byte i = 0; i < BUTTONCOUNT; i++) {
        pinMode(buttons[i], INPUT_PULLUP);
        if (digitalRead(buttons[i]) == LOW) {
            buttonStates[i]++;
        } else {
            if (buttonStates[i] == 0)
                continue;
            if (buttonStates[i] == 255)
                buttonStates[i] = 0;
            else
                buttonStates[i] = 255;
        }
        pinMode(buttons[i], INPUT);
    }
	

}