/*
  Joypad.h - Arduino Game Engine for a ST7565 based 12864 LCD.
  Created by Thomas Baum, th.baum@online.de, 27.10.2015
*/

#ifndef _Joypad_H_
#define _Joypad_H_

#include <Arduino.h>

//PINS
#define JOYPAD_BUTTON_RIGHT_PIN A1
#define JOYPAD_BUTTON_LEFT_PIN A0
#define JOYPAD_BUTTON_DOWN_PIN A3
#define JOYPAD_BUTTON_UP_PIN A2
#define JOYPAD_BUTTON_A_PIN 4
#define JOYPAD_BUTTON_B_PIN 5
#define JOYPAD_SPEAKER_PIN 3
#define JOYPAD_GND_PIN 7
#define JOYPAD_GND_SPEAKER_PIN 2

//NAMES
#define RIGHT 0
#define LEFT 1
#define DOWN 2
#define UP 3
#define A 4
#define B 5

#define BUTTONCOUNT 6

class Joypad {
public:
    void init();
    void update();
    boolean isPressed(byte button);
    boolean isReleased(byte button);
    boolean repeat(byte button, byte period);
    uint8_t isLongPressed(byte button);
private:
    byte buttons[BUTTONCOUNT];
    byte buttonStates[BUTTONCOUNT];

};

#endif

